# Alyzer

> Web interface for stats and graphs computed from a CouchDB database.

Alyzer allows you to generate graphs from CouchDB data, and display them in
a web interface


## Demo

[Demo](http://alyzer-demo.herokuapp.com/)

* Username: guest
* Password: guest

Each time a commit is pushed to Alyzer's GitHub repository, a new document
describing it is added to the demo database. See [GitHub's post-hook
documentation](https://help.github.com/articles/post-receive-hooks) for more
information.


## Screenshots

![Histogram example](http://f.cl.ly/items/1W2u470I29441O3X2w2r/Screen%20Shot%202012-09-05%20at%208.47.34%20PM.png)

![Configuration example](http://f.cl.ly/items/143z421d2e0l173Y0G07/Screen%20Shot%202012-09-05%20at%208.47.53%20PM.png)


## Installation

### Prerequisites

1. Set up a CouchDB server.
2. Make sure you have a working Ruby environment.

### Install

1. Clone the GitHub repository:

    git clone https://github.com/pelletier/alyzer.git

2. Install the required gems using bundle (install it if needed):

    bundle install

3. Make sure your CouchDB server is installed, and run the installation script:

    rake install:run

4. Start the application:

    foreman start -f Procfile.dev

You're ready to go. Just visit `http://localhost:8080/`.


## Configuration

### Database settings

Alyzer needs 2 database-related settings to work:

1. The URL of the CouchDB server.
2. The database name.

At launch, the application starts by reading `config/db.yml`. If it does not
exist, it uses the environment variables `ALYZER_COUCH_URL` and
`ALYZER_COUCH_DB`.

The `db.yml` is automatically generated by the `rake config:db` command.

### Create first user

Use the `rake user:create` command. Make sure you have configured the database
before you run this command.


## Deployment on Cloudant and Heroku

An easy way to run Alyzer is to create a database on
[Cloudant](http://cloudant.com/) and an application on
[Heroku](http://heroku.com/).

Once you have registered, create a new database on Cloudant and generate an API
key and password with all but admin permissions, note it down, and proceed:


1. Clone the GitHub repository:

    git clone https://github.com/pelletier/alyzer.git

2. Create an Heroku app:

    heroku create

3. Deploy:

    git push heroku master

4. Set the configuration settings:

    `heroku config:add ALYZER_COUCH_URL=https://apikey:apipassword@yourname.cloudant.com`
    `heroku config:add ALYZER_COUCH_DB=yourdbname`

5. Create the first user:

    heroku run rake user:create

You're done! Have fun.


## License

MIT (see LICENSE).
